# Currency Exchange Micro Service - H2
tesitng 

ji

Run com.in28minutes.microservices.currencyconversionservice.CurrencyConversionServiceApplicationH2 as a Java Application.
heyyy god
## Resources 
hey god 
hey god pleasse work this docker build
test
heygod pls work
h
please god work
please god
testing
gopi
p,s work
india
thank god i hope this will work
jiiijiji
ho god pls woek this jfrog
god
final testing

oh god please work 

testing the jfrog 

hey god pls work
hey god pls work

pipeline testing

pipelines ci/cd testing 

mastanvali

- http://localhost:8000/currency-exchange/from/USD/to/INR

```json
{
  "id": 10001,
  "from": "USD",
  "to": "INR",
  "conversionMultiple": 65.00,
  "environmentInfo": "NA"
}
```

## H2 Console

- http://localhost:8000/h2-console
- Use `jdbc:h2:mem:testdb` as JDBC URL


## Notes

## Tables Created
```
create table exchange_value 
(
	id bigint not null, 
	conversion_multiple decimal(19,2), 
	currency_from varchar(255), 
	currency_to varchar(255), 
	primary key (id)
)
```

## Containerization

### Troubleshooting

- Problem - Caused by: com.spotify.docker.client.shaded.javax.ws.rs.ProcessingException: java.io.IOException: No such file or directory
- Solution - Check if docker is up and running!
- Problem - Error creating the Docker image on MacOS - java.io.IOException: Cannot run program “docker-credential-osxkeychain”: error=2, No such file or directory
- Solution - https://medium.com/@dakshika/error-creating-the-docker-image-on-macos-wso2-enterprise-integrator-tooling-dfb5b537b44e

### Creating Container

- mvn package

### Running Container

#### Basic
```
docker container run --publish 8000:8000 in28min/currency-exchange:0.0.1-SNAPSHOT


```








from scratch end to end:



step1: create the world's best gitlab file/folder system 
               seperate the app.properties and  app's start-up script files from main app code repo to avoid unnecessary mvn builds.
               create the devops area folder for all devops related work to manage the main code applications.





step2: create a new jenkins server

                1) launc a new ec2 instance

                2) install java 11 on instance 

                    sudo yum update –y

                    sudo amazon-linux-extras install java-openjdk11 -y

                    update java HOME_PATH in .profile

                      find /usr/lib/jvm/java-1.8* | head -n 3  // to find java home_path

                         ex:  /usr/lib/jvm/java-11-openjdk-11.0.20.0.8-1.amzn2.0.1.x86_64 

                        vi ~/.bash_profile  //upting for maven also and java too at a time 

                                        M2_HOME=/opt/maven
                                        M2=/opt/maven/bin
                                        JAVA_HOME=/usr/lib/jvm/java-11-openjdk-11.0.20.0.8-1.amzn2.0.1.x86_64
                                        # User specific environment and startup programs

                                        PATH=$PATH:$HOME/bin:$JAVA_HOME:M2_HOME:$M2
                                        
                        Once done run below command to update the .bash file 

                            Source  ~/.bash_profile 

                            echo $PATH  // it tell path updated or not











                    




                    netstat -tuln





                create jenkins server  and run as container
                 1) create  new aws vm
                 2) install docker on vm
                 3) pull jenkins image and run as container



step2: add slave server to jenkins master server to distribute the load .
            a)create a new slave server and install java software on it
                 a1) first install java on agent/slave before adding it to master jenkins server and create a home dir in slave
                      jenkins master and slave should have same java versions.
                                 yum list installed java*  // to list java versions in server
                                 sudo amazon-linux-extras list | grep java  // to list the java versions
                                amazon-linux-extras install java-openjdk11   / to install java 
                                sudo alternatives --config java // update the new installed version as running version if we have 2 
                                versions of java in single server  // no need to set java home path etc just installed java 
                  a2) slave launch menthod:
                       lanuch via ssh keys
                           shares the jenkins master server public key to slave machine for the first time it will ask passwd for ec2
                           server then it won't ask next time
                           copy the jenkins server ssh private key and create cred on jenkins ui to login to slave machine 
                                     1) on jenkins slave machine
                                             Cd /home/ec2-user/.ssh
                                             Ls -lrt
                                             Cat id_ras   // copy the priavate key of slave machine
                                             Login to jenkin master server ui and create a cred kind user name and private key
                                             User name : ec2-user
                                             Private key:       // paste the priavet key of jenkins slave                                                SSH agent plugin

                                     2) on slave machine 
                                             Cat id_ras.pub  // copy the public key of slave machine
                                      Add the public key of jenkins slave machine in autheriozed_keys of jenkins slave machine it self




step3: install docker on jenkins slave for CI process

      







questions:
1) how to give jenkins view permissions to others? 





upgrade strategy:

1) jenkins and other devops tools  as docker containers
2) use shared lib in jenkins file
3) jenkins slaves are like containers or pods






